# data oracle function for session 3 homework
import random
import numpy as np
def generate_video(width=64,height=48,T=None,label=None,box_width=10,box_height=10):
    # if T is none, select the time at random
    if T is None:
        T = random.randrange(32,64)
    # initialize the video as numpy array
    X = np.zeros((T, width, height))
    # if label is none, select the label at random
    if label is None:
        label = random.randrange(2)
    # choose the radius of the movement
    lo = min(box_width, box_height)
    r = random.randrange(int(0.5*lo), int(1.5 * lo))
    # choose an initial position for the shape
    x_init = random.randrange(0, width - 2*r - box_width - 1)
    y_init = random.randrange(0, height - 2*r - box_height - 1)
    # compute auxiliary variables
    if label == 0:
        freq = 1. / r
    # start moving periodically, either in a circular or in a box path, depending
    # on the label
    # perform the movement
    for t in range(T):
        # determine current position in the frame, depending on the label
        if label == 0:
            # circular movement
            x = x_init + r * (1. + np.sin(t * freq))
            y = y_init + r * (1. + np.cos(t * freq))
        else:
            # box movement
            tau = t % (8*r)
            if tau < 2*r:
                x = x_init + tau
                y = y_init
            elif tau < 4*r:
                x = x_init + 2*r
                y = y_init + tau - 2*r
            elif tau < 6*r:
                x = x_init + 2*r - (tau - 4*r)
                y = y_init + 2*r
            else:
                x = x_init
                y = y_init + 2*r - (tau - 6*r)
        x = int(x)
        y = int(y)
        # draw box in the current frame
        for i in range(box_width):
            X[t, x+i, y:(y+2)] = 1.
            X[t, x+i, (y+box_height-2):(y+box_height)] = 1.
        for j in range(box_height):
            X[t, x:(x+2), y+j] = 1.
            X[t, (x+box_width-2):(x+box_width), y+j] = 1.
    # return result
    return X, label
